class Point
	{
	private:
		double co_ords[4];

	public:
		Point();
		Point(Point &old);
		Point(double x, double y, double z, double w = 1);
		Point *operator = (Point &old);
		friend Point operator +(Point &p1, Point &p2);// add points       p1 + p2
		friend Point operator -(Point &p1, Point &p2);// subtract points  p1 - p2
		friend Point operator *(Point &p1, Point &p2);// cross product    p1 x p2
		friend double operator %(Point &p1, Point &p2);// dot product      p1 . p2
		friend double operator !(Point &p1);//length of vector p1          ||p1||
	};