class Sphere
	{
	private:
		Point location;
		float radius;
		float amb_coef;
		float spe_coef;
		float dif_coef;
		float spe_expo;
		Light_in *refr_coef;
		Light_in *refl_coef;
		float refr_index;
	public:
		Sphere();
		~Sphere();
//                void set_sphere();//when the interface appears
		// set the spheres attributes
		void set_location(Point new_location);
		void set_radius(float new_radius) 	  { radius = new_radius; };
		void set_amb_coef(float new_amb_coef) 	  { amb_coef = new_amb_coef; };
		void set_spe_coef(float new_spe_coef)	  { spe_coef = new_spe_coef; };
		void set_dif_coef(float new_dif_coef)	  { dif_coef = new_dif_coef; };
		void set_spe_expo(float new_spe_expo)	  { spe_expo = new_spe_expo; };
		void set_refr_coef(Light_in *new_refr_coef)   { refr_coef = new_refr_coef;};
		void set_refl_coef(Light_in *new_refl_coef)   { refl_coef = new_refl_coef;};
		void set_refr_index(float new_refr_index) { refr_index = new_refr_index;};

		// read the spheres attributes
		float get_radius(void)		{ return radius;    };
		float get_amb_coef(void)  	{ return amb_coef;  };
		float get_spe_coef(void)	{ return spe_coef;  };
		float get_dif_coef(void)	{ return dif_coef;  };
		float get_spe_expo(void)	{ return spe_expo;  };
		Light_in get_refr_coef(void)	{ return refr_coef; };
		Light_in get_refl_coef(void)   	{ return refl_coef; };
		float get_refr_index(void) 	{ return refr_index;};

		//functions to act on incident ray
		Light_in *calculate(Light_in *incident);
		Light_in *reflect(Light_in *incident);
		Light_in *refract(Light_in *incident);

	};