typedef enum {false, true} boolean;
typedef double trans_matrix[4][4];
typedef double point[4];
void vector_add(point to, point a,point b);
void vector_scalar_mult(point vector, double scalar);
void identity(trans_matrix the_matrix);
void rotate_x(trans_matrix the_matrix,double angle);
void rotate_y(trans_matrix the_matrix,double angle);
void rotate_z(trans_matrix the_matrix,double angle);
void translate(trans_matrix the_matrix, point distances);
void concat_trans_matricies(trans_matrix matrix1,
			    trans_matrix matrix2,
			    trans_matrix result);
void cross_product(point a, point b, point result);
boolean point_in_triangle(point a, point tri, point ang, point le);
double point_z_location(point a,point tri,point ang,point le);
void vector_copy(point new_vector, point old_vector);
void vector_mult(point old,trans_matrix operation,point the_new);
double dot_product(point v1,point v2);
double vector_len(point v);
void normalise(point vector);
void vector_from_points(point p1, point p2, point vector);
