#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "node.h"
#include "coder.h"
Coder::Coder()
	{
	long int j;
	int i;
	unsigned char inbyte;
	for (i=0;i<256;i++)
		{
		nodes[i] = new Node(i);
		}
	// read in file to array.
	fpin = fopen("voice.wav","r");
	for (j=0;j<163000;j++)
		{
		inbyte = fgetc(fpin);
		nodes[inbyte]->IncCount();
		}
	}

Coder::~Coder()
	{
	};

void Coder::MergeNodes(Node *a, Node *b)
	{
	// create a new node
	Node *newnode;
	newnode = new Node();
	// copy b to it
	newnode->SetValue(b->GetValue());
	newnode->SetCount(b->GetCount());
	newnode->SetLeft(b->GetLeft());
	newnode->SetRight(b->GetRight());
	// hang newnode and a off b
	newnode->SetParent(b);
	a->SetParent(b);
	// update b's stuff to reflect new status
	b->SetLeft(a);
	b->SetRight(newnode);
	b->SetCount(newnode->GetCount() + a->GetCount());
	b->SetValue(999);
	}

void Coder::SortArray(int sizeofarray)
	{
	int i, j=0,temp,c;
	Node *swap;
/*		for(c=0;c<16;c++)
			printf("  %ld \t",nodes[c]->GetCount());
	printf("\n");
	getch();
 */
	for (j=0;j<sizeofarray;j++)
		{
		temp = j;
		for (i=j;i<sizeofarray;i++)
			{
			//printf("j=%d  i=%d\n",j,i);
			if (nodes[temp]->GetCount() < nodes[i]->GetCount())
				{
				// we want the largest @ front

				//swap = temp;
				temp = i;
				//nodes[i] = swap;
				}
			}
		// now we have found the largest, put at front
		// largest is in temp
		swap = nodes[temp];
		nodes[temp] = nodes[j];
		nodes[j] = swap;

/*		for(c=0;c<16;c++)
			printf("  %ld \t",nodes[c]->GetCount());
		printf("\n");
		getch();
*/
		}

 //	for(i=0;i<25;i++)
 /*		for(c=0;c<16;c++)
			printf("  %ld \t",nodes[c]->GetCount());
		printf("\n");
		getch();
/*		i=245;
		{
		for(j=0;j<10;j++)
			printf("%d  %ld \n",(i)+j,nodes[(i)+j]->GetCount());
		}
	getch();
*/
	}
void Coder::BuildCodes()
	{
	int nodesleft=255;
	//int sortfn(void *,void *);
	// sort nodes, get both smallest, extract from
	// array and replace larger with new node which is composite
	// then resort and repeat until nodesleft = 1
	//sortfn = &this->sortfn;
	while (nodesleft > 0)
		{
		SortArray(nodesleft+1);
		// merge the two smallest nodes
		// they will be nodes[nodesleft] and nodes[nodesleft-1]
		MergeNodes(nodes[nodesleft],nodes[nodesleft-1]);
		nodesleft--;
		printf("loop %d \n",nodesleft);

		}
	};

void Coder::PrintCodes()
	{
	nodes[0]->Print(-1,0);
	}
void main(void)
	{
	Coder *encoder;
	encoder = new Coder();
	encoder->BuildCodes();
	encoder->PrintCodes();
	};