-- File: catalogue.e
-- The class CATALOGUE represents a collection of books in library
-- Which we have represented as a list construct
class CATALOGUE

inherit
	EDITABLE_LIST[BOOK] -- add, remove, search
	rename
		make as editable_list_make,
		display as editable_list_display
	end -- inherit
creation
	make
feature

-----------------------------------------------------------------------------
-- The function displays the prompt for adding a book to the library
	add_prompt is
		do
			io.put_string("Add a Book")
			io.put_newline
			io.put_newline
	end -- add_prompt

-----------------------------------------------------------------------------
-- The function displays the prompt for deleting a book from the library
	delete_prompt is
		do
			io.put_string("Delete a Book")
			io.put_newline
			io.put_newline
	end -- delete_prompt

-----------------------------------------------------------------------------
-- The function displays an error message for adding a book with a duplicate
-- barcode
	add_error is
		do
			io.put_string("That barcode already exists!")
			io.put_newline
	end -- add_error

-----------------------------------------------------------------------------
-- This function loads the catalogue
	load is
		local
			tf : TEXTFILE
		do
			!!tf.connect_to(fs.access_file("catalogue.dat","r",false)) -- is this correect parameters ??
			from
				index = 0
				-- point to start of editable_list

			until
				index >= tf.count
			loop

				index =
				-- go to next thing in editable_list
			end -- loop
	end -- load
-----------------------------------------------------------------------------
-- This function saves the catalogue
	save is
		local
			tf : TEXTFILE
			book : BOOK
		do

	end -- save
-----------------------------------------------------------------------------
-- The function displays an error message for deleting a book that does not
-- exist
	delete_error is
		do
			io.put_string("That book barcode doesn't exist!")
			io.put_newline
	end -- delete_error

-----------------------------------------------------------------------------
-- The function displays the title for the book list
	display is
		do
			editable_list_display("Book List")
	end -- display

-----------------------------------------------------------------------------

	make is
		do
			editable_list_make
	end -- make

-----------------------------------------------------------------------------

end -- CATALOGUE

