//#include <owl\owlall.h>
#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\listbox.h>
#include <owl\layoutwi.h>
#include <owl\static.h>
#include <owl\gdiobjec.h>
#include <owl\combobox.h>
#include <owl\button.h>
#include <owl\opensave.h>
#include <owl\menu.h>
#include <owl\editfile.rh>

#pragma hdrstop

#include <string.h>
#include <stdlib.h>
#include "file.h"
#include "inifile.h"
Inifile::Inifile()
	{
//	char *path;
//	char pathdir[132];
	//try the windir - variable not set in windows
//	path = getenv("WINDIR");
//	sprintf(pathdir,"%s\winmenu.ini",path);

	InFile = new MyFile("winmenu.ini");
	Files[ID_TempFile] = new FileNames;
	Files[ID_MenuFile] = new FileNames;
	Files[ID_WinDir  ] = new FileNames;
	Files[ID_TempFile]->assigned=0;
	Files[ID_MenuFile]->assigned=0;
	Files[ID_WinDir  ]->assigned=0;

	while (!feof(InFile->fp))
			{
			InFile->GetString();
			if (!strncmpi(InFile->LastString,"tempfile=",9))
				{
				strcpy(Files[ID_TempFile]->FileName,&InFile->LastString[9]);
				Files[ID_TempFile]->assigned=1;
				}
			if (!strncmpi(InFile->LastString,"menu=",5))
				{
				strcpy(Files[ID_MenuFile]->FileName,&InFile->LastString[5]);
				Files[ID_MenuFile]->assigned=1;
				}
			if (!strncmpi(InFile->LastString,"windir=",7))
				{
				strcpy(Files[ID_WinDir]->FileName,&InFile->LastString[7]);
				Files[ID_WinDir]->assigned=1;
				}

			}

	// if something not defined, give error meesge explaining how to fix.
	if  (!Files[ID_MenuFile]->assigned)
		{
		MessageBox(0,"Need a line in winmenu.ini \n menu=menupath.mnu","Menu Error",MB_OK);
		exit (0);
		}
	if  (!Files[ID_TempFile]->assigned)
		{
		MessageBox(0,"Need a line in winmenu.ini \n Tempfile=tempfilepath.bat","Menu Error",MB_OK);
		exit (0);
		}
	if  (!Files[ID_WinDir]->assigned)
		{
		MessageBox(0,"Need a line in winmenu.ini \n windir=drive:\windowsdirecory","Menu Error",MB_OK);
		exit (0);
		}
	}
void Inifile::WriteTo()
	{
	FILE *fp;
	char pathdir[132];
	sprintf(pathdir,"%s\\winmenu.ini",Files[ID_WinDir]->FileName);
	fp = fopen(pathdir,"r");
	if (!fp)
		{
		MessageBox(0,"Cannot write to winmenu.ini, changes will not be saved.","Menu Error",MB_OK);
		}
	else
		{
		fprintf(fp,"[winmenu.ini]\n");
		fprintf(fp,"menu=%s\n",Files[ID_MenuFile]->FileName);
		fprintf(fp,"tempfile=%s\n",Files[ID_TempFile]->FileName);
		fprintf(fp,"windir=%s\n",Files[ID_WinDir]->FileName);
		fclose(fp);
		}
	}
